---
- name: Update repositories cache and install required package
  apt:
    name:
    - apt-transport-https
    - ca-certificates
    - curl
    - gnupg
    - lsb-release
    update_cache: yes
    force_apt_get: yes
  become: true

- name: Add Docker's official GPG key
  shell: "curl -fsSL https://download.docker.com/linux/debian/gpg | gpg --batch --yes --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg"
  args:
    warn: false
  become: true

- name: Add Docker's official software repository
  shell: 'echo \
  "deb [arch=amd64 signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/debian $(lsb_release -cs) stable" | tee /etc/apt/sources.list.d/docker.list > /dev/null'
  become: true

- name: Install docker-ce version 20.10.8
  apt:
    name: docker-ce=5:20.10.8~3-0~debian-bullseye
    update_cache: yes
  become: true

- name: Ensure that there's no existing Docker daemon.json config file
  stat:
    path: /etc/docker/daemon.json
  register: docker_config_initial
  become: true

- name: Copy Docker daemon.json config file to enable log rotation and limits
  copy:
    src: daemon.json
    dest: /etc/docker/daemon.json
  become: true
  register: docker_config_proposed
  when: not docker_config_initial.stat.exists

- name: Restart Docker daemon
  systemd:
    state: restarted
    name: docker
  become: true
  when: docker_config_proposed.changed
